(* uiDevice.ml     Wrapper for Cocoa Touch UIDevice
 *
 * Copyright (c) 2011 Psellos   http://psellos.com
 * Licensed under the MIT license:
 *     http://www.opensource.org/licenses/mit-license.php
 *)
type orientation =
      OrientationUnknown
    | OrientationPortrait
    | OrientationPortraitUpsideDown
    | OrientationLandscapeLeft
    | OrientationLandscapeRight
    | OrientationFaceUp
    | OrientationFaceDown

external _orientation : nativeint -> orientation = "UIDevice_orientation"
external _beginGeneratingDeviceOrientationNotifications : nativeint -> unit =
    "UIDevice_beginGeneratingDeviceOrientationNotifications"

class t robjcv =
    object (self)
    inherit Wrapper.t robjcv

    method orientation =
        _orientation self#contents
    method beginGeneratingDeviceOrientationNotifications =
        _beginGeneratingDeviceOrientationNotifications self#contents
    end

let _ =
    let wrap robjcv =
        new t robjcv
    in
        Callback.register "UiDevice.wrap" wrap

external _currentDevice : unit -> t = "UIDevice_currentDevice"

let currentDevice () =
    _currentDevice ()
